program killsanta;

{$mode objfpc}{$H+}

uses
  {$IFDEF UNIX}{$IFDEF UseCThreads}
  cthreads,
  {$ENDIF}{$ENDIF}
  Classes, SysUtils, CustApp
  { you can add units after this };

type

  { _killsanta }

  _killsanta = class(TCustomApplication)
  protected
    procedure DoRun; override;
  public
    constructor Create(TheOwner: TComponent); override;
    procedure WriteHelp; virtual;
  end;

{ _killsanta }

const
	_cmpeax352 = #$3D#$5F#$01#$00#$00;
      	_cmpeax354 = #$3D#$61#$01#$00#$00;
var
   S: String;
   TM: TMemoryStream;
   i, j: Integer;

Function Copy(S: String; Start, Count: Integer): String;
var i, Stop: Integer;
Begin
     Result := '';
     Stop := (Start + Count) - 1;
     For i := Start To Stop Do Result := Result + S[i];
end;

Function GetPos(Where, What: String; Offset: Integer): Integer;
var
   i: Integer;
   found: Boolean;
Begin
     found := False;
     i := Offset;
     Repeat
           If Where[i] = What[1] Then Begin
              If Copy(Where, i, Length(What)) = What Then Begin
                 found := True;
                 Result := i;
              end;
           end;
           Inc(i);
     Until (i > Length(Where)) Or found;
     If NOT found Then Result := -1;
end;

Procedure PokeFile(FileName: String; Position: Int64; Value: Byte);
var F: File of Byte;
Begin
	AssignFile(F, FileName);
	ReSet(F);
	Seek(F, Position);
	Write(F, Value);
	CloseFile(F);
end;

procedure _killsanta.DoRun;
var
  ErrorMsg: String;
begin
  // quick check parameters
  ErrorMsg:=CheckOptions('h','help');
  if ErrorMsg<>'' then begin
    ShowException(Exception.Create(ErrorMsg));
    Terminate;
    Exit;
  end;

  // parse parameters
  if HasOption('h','help') then begin
    WriteHelp;
    Terminate;
    Exit;
  end;

	If NOT SysUtils.FileExists(ParamStr(1)) Then Begin
		WriteLn('File does not exists.');
	end Else Begin
		TM := TMemoryStream.Create;
		TM.LoadFromFile(ParamStr(1));
		SetString(S, TM.Memory, TM.Size div SizeOf(Char));
		TM.Free;
                j := 0;
		Repeat
			j := GetPos(S, _cmpeax354, j + 6);
			If j <> -1 Then Begin
	                   	WriteLn('Reference-354 removed at: 0x' + SysUtils.IntToHex(j - 1, 8));
                                PokeFile(ParamStr(1), j + 2, $71);
			end;
		until j = -1;
                j := 0;
		Repeat
			j := GetPos(S, _cmpeax352, j + 6);
			If j <> -1 Then Begin
	                   	WriteLn('Reference-352 removed at: 0x' + SysUtils.IntToHex(j - 1, 8));
                                PokeFile(ParamStr(1), j + 2, $71);
			end;
		until j = -1;
	end;


  // stop program loop
  Terminate;
end;

constructor _killsanta.Create(TheOwner: TComponent);
begin
  inherited Create(TheOwner);
  StopOnException:=True;
end;

procedure _killsanta.WriteHelp;
begin
  WriteLn('"Kill santa" - santa icon remover for vlc by TCH');
  writeln('Usage: killsanta <filename>');
  WriteLn('E.g.: killsanta /usr/lib/vlc/plugins/gui/libqt4_plugin.so');
end;

var
  Application: _killsanta;

{$R *.res}

begin
  Application:=_killsanta.Create(nil);
  Application.Title:='kill santa in vlc';
  Application.Run;
  Application.Free;
end.

